#include <iostream.h>
#include <math.h>

#include "matlib.h"


char *sformat="%10.4lg";

ostream &operator<<(ostream &outp, DVector &A)
{
  int i,imax;

  imax = A.Length(1);

  printf("[ ");
  for (i=1; i<=imax; i++) {
    printf(sformat,A(i));          // %6.4le
    if (i<imax)
      printf("  ");
  }
  printf(" ]\n");

  return outp;
}


ostream &operator<<(ostream &outp, DMatrix &A)
{
  int i,j,imax,jmax;

  imax = A.Length(1);
  jmax = A.Length(2);

  for (i=1; i<=imax; i++) {
    printf("[ ");
    for (j=1; j<=jmax; j++) {
      printf(sformat,A(i,j));
      if (j<jmax)
        printf("  ");
    }
    printf(" ]\n");
  }

  return outp;
}


ostream &operator<<(ostream &outp, DArray3 &A)
{
  int i,j,k,imax,jmax,kmax;

  imax = A.Length(1);
  jmax = A.Length(2);
  kmax = A.Length(3);

  for (k=1; k<=kmax; k++) {
    printf("(*,*,%d) = \n",k);
    for (i=1; i<=imax; i++) {
      printf("[ ");
      for (j=1; j<=jmax; j++) {
        printf(sformat,A(i,j,k));
        if (j<jmax)
          printf("  ");
      }
      printf(" ]\n");
    }
  }

  return outp;
}


ostream &operator<<(ostream &outp, DArray4 &A)
{
  int i,j,k,l,imax,jmax,kmax,lmax;

  imax = A.Length(1);
  jmax = A.Length(2);
  kmax = A.Length(3);
  lmax = A.Length(4);

  for (l=1; l<=lmax; l++) {
    for (k=1; k<=kmax; k++) {
      printf("(*,*,%d,%d) = \n",k,l);
      for (i=1; i<=imax; i++) {
        printf("[ ");
        for (j=1; j<=jmax; j++) {
          printf(sformat,A(i,j,k,l));
          if (j<jmax)
            printf("  ");
        }
        printf(" ]\n");
      }
    }
  }

  return outp;
}

//---------------------------------------------------------------------------------------------------

// supremum - nejblizsi vyssi cele cislo:  sup(1.3)=2, sup(5.8)=2, sup(6)=6
int sup(double value)
{
  int fvalue;

  fvalue = (int) floor(value);
  if (value>fvalue)
    return fvalue+1;
  else
    return fvalue;
}

